﻿Type=Activity
Version=1.60
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim ButtonExit As Button
	Dim LabelDeletedItem As Label
	Dim ButtonSaveColors As Button
	Dim SaveColorsList, ByteList As List 
	Dim LabelColors, LabelColorsText As Long 
	Dim gd1 As GradientDrawable
	Dim cols1(2) As Int
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Deleted")
	cols1(0) = Colors.LightGray 
	cols1(1) = Colors.LightGray
	gd1.Initialize("TOP_BOTTOM",cols1)
	gd1.CornerRadius = 30
	LabelDeletedItem.Text = CodeModule.DeleteNotice 
	SaveColorsList.Initialize 
	If File.Exists (File.DirInternal,"SaveColors.txt") Then
		If File.Size(File.DirInternal,"SaveColors.txt") > 0 Then 
			SaveColorsList.Clear 
 			SaveColorsList = File.ReadList(File.DirInternal,"SaveColors.txt") 
			LabelColors = SaveColorsList.Get(0)
			LabelDeletedItem.Color = LabelColors
			LabelColorsText = SaveColorsList.Get(1)
			LabelDeletedItem.TextColor = LabelColorsText 
		Else
			LabelDeletedItem_Click
		End If
	Else
		LabelDeletedItem_Click
	End If	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
Sub LabelDeletedItem_Click
	LabelColors = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelColorsText = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelDeletedItem.Color = LabelColors
	LabelDeletedItem.TextColor = LabelColorsText
End Sub
Sub ButtonSaveColors_Click
Select Msgbox2("Save Colors?" & CRLF & CRLF & LabelColors & CRLF & CRLF & LabelColorsText," ", "Yes", "", "No", CodeModule.TCAlogo) 
  Case DialogResponse.POSITIVE
	'Msgbox("POSITIVE","")
	SaveColorsList.Clear
	SaveColorsList.Add(LabelColors)
	SaveColorsList.Add(LabelColorsText)
	File.WriteList(File.DirInternal,"SaveColors.txt",SaveColorsList) 
	Msgbox (LabelColors & " " & LabelColorsText,"Colors Saved!")
  Case DialogResponse.CANCEL
	'Msgbox("CANCEL","")
  Case DialogResponse.NEGATIVE
	'Msgbox("NEGATIVE","")
End Select
End Sub
Sub ButtonExit_Click
	Activity.Finish 
	Select Case CodeModule.DeleteItemFlag
		Case 0
			StartActivity(Main)
		Case 1
			StartActivity(UnZip)
		Case 2
			StartActivity(Zip)
		Case 3
			StartActivity(Delete)
	End Select
End Sub
