﻿Type=Activity
Version=1.60
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
Type node(pnl As Panel,lbl As Label,btn As Button, tag As String,level As Int, parent As node, child As List)
Type treeview(sv As ScrollView, rootnode As node) 

	Dim tv As treeview
	Dim nd(0) As node
	Dim sv As ScrollView
	Dim lineheight,linewidth, delta As Int
	Dim datalist As List
	Dim gd1 As GradientDrawable
	Dim gd2 As GradientDrawable
	Dim cols1(2) As Int
	Dim cols2(2) As Int
	Dim LabelDstDir As Label
	Dim LabelSrcDir As Label
	Dim LabelSrcFile As Label
	Dim ToggleButtonSrcDst As ToggleButton
	Dim SrcDst As Boolean 
	Dim ButtonUnZip As Button
	Dim ButtonExit As Button
	Dim ButtonHelp As Button
	Dim LabelPanelMainTitle As Label
	Dim PanelMain As Panel
	Dim TCApicBD As BitmapDrawable 
End Sub
Sub Activity_Create(FirstTime As Boolean)
Activity.LoadLayout("UnZip.bal")
lineheight = 45dip
linewidth = 250dip
'Default.Initialize 
cols1(0) = Colors.RGB(47,79,79)
cols1(1) = Colors.RGB(47,79,79)
gd1.Initialize("TOP_BOTTOM",cols1)
gd1.CornerRadius = 30

cols2(0) = Colors.RGB(47,79,79)
cols2(1) = Colors.RGB(47,79,79)
gd2.Initialize("TOP_BOTTOM",cols2)
gd2.CornerRadius = 30

SrcDst = True
MsgFlag = False
CodeModule.DirRootExternalList = File.ListFiles(File.DirRootExternal)

tv.Initialize
tv.sv.Initialize(activity.Height)
activity.AddView(tv.sv,0,200,activity.Width,activity.Height)
tv.sv.Panel.Height = 15000

tv.rootnode.Initialize
tv.rootnode.pnl.Initialize("PanelMain")
tv.rootnode.btn.Initialize("")
tv.rootnode.lbl.Initialize("")
tv.rootnode.child.Initialize
tv.rootnode.btn.Visible = False
tv.rootnode.lbl.Text = "SdCard:"
tv.rootnode.lbl.TextSize = 14
tv.rootnode.lbl.TextColor = Colors.RGB(127,255,0)
tv.rootnode.tag = File.DirRootExternal  ' example for directory treeview
tv.rootnode.level = 0 
'tv.sv.Panel.AddView(tv.rootnode.pnl,0,0,linewidth,lineheight)
'tv.sv.Panel.AddView(tv.rootnode.lbl,0,3dip,linewidth-lineheight,lineheight-10)
'tv.sv.Panel.AddView(tv.rootnode.btn,3dip,3dip,lineheight-6dip,lineheight-6dip)
tv.sv.Panel.AddView(tv.rootnode.pnl,0,0,100dip,lineheight)
tv.sv.Panel.AddView(tv.rootnode.lbl,0,0,100dip,lineheight)
tv.sv.Panel.AddView(tv.rootnode.btn,0,0,100dip,lineheight)

If get_data(tv.rootnode.tag) Then ' assign the first level of nodes
	Dim nd(datalist.Size) As node
	For i = 0 To datalist.Size-1
		nodeinit(i,datalist.Get(i), tv.rootnode)
	Next
Else
	Msgbox("Files not accessible","")
End If

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
Sub get_data(dir As String)  ' this sub is now for files management, can be adapted to other kinds of data to be shown as tree
datalist.Initialize
datalist = File.ListFiles(dir)
If datalist.IsInitialized = False OR datalist.size < 1 Then Return False Else Return True
End Sub

Sub nodeinit(k,text,parent As node)

nd(k).Initialize
nd(k).pnl.Initialize("")
nd(k).lbl.Initialize("lbl")
nd(k).btn.Initialize("btn")
nd(k).child.Initialize
If File.IsDirectory(parent.tag,text) Then ' specific for files, for the case that  items can or cannot be opened ( directory - file)
	nd(k).btn.Text = "."
	nd(k).btn.SetBackgroundImage(CodeModule.Plus)
Else
	nd(k).btn.Visible = False
	nd(k).btn.Text = "F"
End If
'nd(k).btn.TextSize = 14
nd(k).btn.TextSize = 10
nd(k).btn.tag = nd(k)
nd(k).lbl.Text = text
'nd(k).lbl.TextSize = 20
nd(k).lbl.TextSize = 12
nd(k).lbl.TextColor = Colors.RGB(127,255,0)
nd(k).lbl.Background = gd1
nd(k).lbl.Tag = nd(k)
nd(k).level = parent.level + 1
nd(k).parent = parent
nd(k).tag = nd(k).parent.tag & "/" & text ' specific for file manager.
nd(k).pnl.Background = gd2
' Tag can be used for any data that you want to store in a node, in addition to the text. Here I use the path & filename.
nd(k).pnl.AddView(nd(k).btn,3dip,3dip,lineheight-6dip,lineheight-6dip)
nd(k).pnl.AddView(nd(k).lbl,lineheight,3dip,linewidth-lineheight,lineheight-6dip)
'nd(k).pnl.AddView(nd(k).lbl,6dip,3dip,linewidth-lineheight,lineheight-6dip)
If nd(k).parent.pnl.Top + (k+1)*lineheight > tv.sv.Panel.Height Then ' extend the panel if it is too short...
	tv.sv.Panel.Height = tv.sv.Panel.Height + 100
End If
tv.sv.Panel.AddView(nd(k).pnl,nd(k).level*(lineheight-6), nd(k).parent.pnl.Top + (k+1)*lineheight,linewidth,lineheight)
nd(k).parent.child.Add( nd(k))
End Sub
Sub btn_click
Dim b As Button
Dim tnode As node

Try
b = Sender

If b.Text = "." Then  ' used as flag between open and closed node
	tnode = b.Tag
							 ' get the list of sub nodes
	If get_data(tnode.tag) Then ' if list is ok, proceed
		b.Text = "" 
		b.SetBackgroundImage(CodeModule.Minus)
		datalist.Sort(True) 
		Dim nd(datalist.Size) As node
		move_nodes( tnode.pnl.Top ,datalist.Size)
		For i = 0 To datalist.Size-1         ' assign data items to new nodes
			nodeinit(i,datalist.Get(i), tnode)
			'DoEvents
		Next
	End If
Else 
	b.Text = "."
	b.SetBackgroundImage(CodeModule.Plus)
	tnode = b.Tag
	delta = 0           ' a counter for collapsed lines
	remove_children(tnode )
	move_nodes( tnode.pnl.Top ,-delta) ' move lower nodes up
End If
Catch
	Msgbox(LastException,"Error")
End Try
End Sub
Sub move_nodes( top As Int,lines As Int)
Dim v As View
For j = 0 To tv.sv.Panel.NumberOfViews - 1  
	v = tv.sv.Panel.GetView(j)
	If v.top  > top Then
		v.Top = v.Top + lines * lineheight
	End If
	'DoEvents
Next
End Sub
Sub remove_children(Rnode As node)  ' close a node
Dim delnode As node

For i =  Rnode.child.Size - 1 To 0 Step - 1
	delta = delta + 1
 	delnode = Rnode.child.Get(i)
								 ' recursion if the sub node is open
	If delnode.btn.Text = "" Then remove_children(delnode) 
	delnode.pnl.RemoveView  ' then delete it
	'DoEvents
Next
Rnode.child.Clear  ' zero the child list in the closing node
End Sub
Sub lbl_click
Dim lb As Label
Dim tnode As node
Dim sParentFolder As String 
Dim sLowerCase
Dim CurIMGNameShort

lb = Sender
tnode = lb.Tag
sParentFolder = tnode.parent.tag  
sLowerCase = lb.Text.ToLowerCase 

LbColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
LbTextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
tnode.pnl.Color = LbColor
lb.Color = LbColor 
lb.TextColor = LbTextColor

If (sLowerCase.EndsWith(".wav") OR sLowerCase.EndsWith(".mp3")  OR sLowerCase.EndsWith(".mid")  OR sLowerCase.EndsWith(".ogg")) Then
	CodeModule.MP.Load(sParentFolder,lb.Text)
	CodeModule.MP.Play
End If
If sLowerCase.EndsWith(".jpg") OR  sLowerCase.EndsWith(".png") OR sLowerCase.EndsWith(".bmp") OR sLowerCase.EndsWith(".gif") Then
			TCApicBD.Initialize(LoadBitmap(sParentFolder, lb.Text))
			TCApicBD.Gravity = Gravity.FILL 
			PanelMain.Background = TCApicBD
			CurIMGNameShort = lb.Text.SubString2(0, lb.Text.IndexOf("."))
			LabelPanelMainTitle.Text = CurIMGNameShort
			LabelPanelMainTitle.Color = LbColor
			LabelPanelMainTitle.TextColor = LbTextColor
End If

If SrcDst Then
	LabelSrcDir.Text = sParentFolder & "/"
	LabelSrcDir.Color = LbColor  
	LabelSrcDir.TextColor = LbTextColor
	
	LabelSrcFile.Text = lb.Text
	LabelSrcFile.Color = LbColor  
	LabelSrcFile.TextColor = LbTextColor 
Else
	LabelDstDir.Text = sParentFolder
	LabelDstDir.Color = LbColor  
	LabelDstDir.TextColor = LbTextColor 
End If
End Sub
Sub ToggleButtonSrcDst_CheckedChange(Checked As Boolean)
	SrcDst = Checked 
End Sub
Sub PanelMain_Click
	LabelDstDir.Text = File.DirRootExternal & "/"
	LabelDstDir.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelDstDir.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	Msgbox(LabelDstDir.Text,"Root Folder Selected")
End Sub
Sub ButtonUnZip_Click
	Select Msgbox2("Do You Wish To Unzip?" & CRLF & CRLF & LabelSrcDir.Text & LabelSrcFile.Text & CRLF & CRLF & "To" & CRLF & CRLF & LabelDstDir.Text," ", "Yes", "", "No", CodeModule.TCAlogo) 
	Case DialogResponse.POSITIVE
		'Msgbox("POSITIVE","")
		If File.Exists(LabelSrcDir.Text,LabelSrcFile.Text) Then
			If File.Size(LabelSrcDir.Text,LabelSrcFile.Text) > 0 Then 
				If File.IsDirectory(LabelDstDir.Text,"") Then
					If LabelSrcFile.Text.ToLowerCase.EndsWith(".zip") Then
						Try
							Msgbox("Please Wait A Few Minutes","Unzipping ...")
							CodeModule.ZipUnzip.ABUnzip(LabelSrcDir.Text & LabelSrcFile.Text, LabelDstDir.Text)
							DoEvents
							Msgbox("Unzipping Completed!","Unzipped")
							Codemodule.DeleteNotice = LabelSrcDir.Text & LabelSrcFile.Text & " UnZipped To -> " & LabelDstDir.Text
							Activity.Finish
							CodeModule.DeleteItemFlag = 1
							StartActivity(Deleted)
						Catch
							Msgbox(LastException,"Error")
						End Try
					Else
						Msgbox(LabelSrcDir.Text & LabelSrcFile.Text,"Not A ZIP File")
					End If
				Else
					Msgbox("Folder Does Not Exist",LabelDstDir.Text)
				End If
			Else
				Msgbox("Folder Is Empty",LabelSrcFile.Text)
			End If
		Else
			Msgbox("Folder Does Not Exist",LabelSrcFile.Text)
		End If	
	Case DialogResponse.CANCEL
		'Msgbox("CANCEL","")
	Case DialogResponse.NEGATIVE
		'Msgbox("NEGATIVE","")
	End Select
End Sub
Sub LabelSrcDir_Click
	LabelSrcDir.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelSrcDir.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub LabelSrcFile_Click
	LabelSrcFile.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelSrcFile.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub LabelDstDir_Click
	LabelDstDir.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelDstDir.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub LabelPanelMainTitle_Click
	LabelPanelMainTitle.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelPanelMainTitle.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub ButtonHelp_Click
	CodeModule.HelpReturnFlag = 1
	StartActivity(TCAHelp)
End Sub
Sub ButtonExit_Click
	Activity.Finish 	
	StartActivity(Main)
End Sub
