﻿Type=Activity
Version=1.60
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim ButtonExit As Button
	Dim LabelCompressedSize As Label
	Dim LabelName As Label
	Dim LabelSize As Label
	Dim ListViewListZip As ListView
	Dim iTextSize As Int : iTextSize = 14
	Dim LabelLine1 As Label
	Dim LabelLine2 As Label
	Dim LabelFileName As Label
	Dim LabelPanelMainTitle As Label
End Sub
Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("ListZipView.bal")
	
	ListviewListZip.Clear 
	ListviewListZip.Color = Colors.RGB(127,255,0)   
	ListViewListZip.SingleLineLayout.ItemHeight = 75dip
	
    ListViewListZip.SingleLineLayout.Label.TextSize = iTextSize * 3
	ListViewListZip.SingleLineLayout.Label.Color = Colors.Black  
    ListViewListZip.SingleLineLayout.Label.TextColor = Colors.Red 
    ListViewListZip.SingleLineLayout.Label.Gravity = Gravity.LEFT 
	
	ListViewListZip.TwoLinesLayout.ItemHeight = 75dip
	
	ListViewListZip.TwoLinesLayout.Label.TextSize = iTextSize 
	ListViewListZip.TwoLinesLayout.Label.Color = Colors.RGB(47,79,79)   
	ListViewListZip.TwoLinesLayout.Label.TextColor = Colors.RGB(127,255,0) 
	
	ListViewListZip.TwoLinesLayout.SecondLabel.TextSize = iTextSize 
	ListViewListZip.TwoLinesLayout.SecondLabel.Color = Colors.RGB(47,79,79) 
	ListViewListZip.TwoLinesLayout.SecondLabel.TextColor = Colors.RGB(127,255,0)  
	
	ListViewListZip.FastScrollEnabled = True

	LabelFileName.Text = CodeModule.ZipListFileName	
	
	For i = 0 To CodeModule.ZipListCounter -1
		CodeModule.ZipContent = CodeModule.ZipUnzip.ABGetListItem(i) 
		ListViewListZip.AddTwoLines(CodeModule.ZipContent.Name, "Size: " & CodeModule.ZipContent.Size & " Bytes Compressed Size: " & CodeModule.ZipContent.CompressedSize & " Bytes")
	Next
	ListViewListZip.AddTwoLines(CodeModule.ZipListCounter,"Items")
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
Sub ListViewListZip_ItemClick (Position As Int, Value As Object)
	LabelLine1.Text = Position 	
	LabelLine2.Text = Value 	
End Sub
Sub LabelSize_Click
	LabelSize.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelSize.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub LabelName_Click
	LabelName.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelName.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub LabelCompressedSize_Click
	LabelCompressedSize.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelCompressedSize.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub LabelLine1_Click
	LabelLine1.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelLine1.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub LabelLine2_Click
	LabelLine2.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelLine2.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub LabelFileName_Click
	LabelFileName.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	LabelFileName.TextColor = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
End Sub
Sub ButtonExit_Click
	Activity.Finish 
	StartActivity(ListZip)
End Sub
